//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  Red
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FastEMA          = 12;
extern int    SlowEMA          = 26;
extern int    SignalEMA        =  9;
extern int    Price            = PRICE_CLOSE;
extern int    MinMaxPeriod     =  50;
extern double LevelUp          =  90;
extern double LevelDown        =  10;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern bool   ArrowsVisible    = false;
extern string ArrowsIdentifier = "MACD arrows";
extern double ArrowsUpGap      = 0.75;
extern double ArrowsDownGap    = 0.75;
extern color  ArrowUpColor     = LimeGreen;
extern int    ArrowUpWidth     = 2;
extern color  ArrowDownColor   = PaleVioletRed; 
extern int    ArrowDownWidth   = 2; 
extern bool   Interpolate      = true;

//
//
//
//
//

double macd[];
double macdDa[];
double macdDb[];
double signal[];
double colors[];
double levelUp[];
double levelMi[];
double levelDn[];

string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
bool   calculateMa;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,levelUp);
   SetIndexBuffer(1,levelMi);
   SetIndexBuffer(2,levelDn);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,macdDa);
   SetIndexBuffer(5,macdDb);
   SetIndexBuffer(6,signal);
   SetIndexBuffer(7,colors);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit()
{
   int lookForLength = StringLen(ArrowsIdentifier);
      for (int i=ObjectsTotal(); i>= 0; i--)
      {
         string name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double emas[][2];
double trend[];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { levelUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      if (ArrayRange(emas,0)  != Bars) ArrayResize(emas ,Bars);
      if (ArrayRange(trend,0) != Bars) ArrayResize(trend,Bars);
         double alphaSign = 2.0/(1.0+SignalEMA);
         double alphaFast = 2.0/(1.0+FastEMA);
         double alphaSlow = 2.0/(1.0+SlowEMA);
         
      //
      //
      //
      //
      //
               
      if (colors[limit]==-1) CleanPoint(limit,macdDa,macdDb);
      for(i = limit, r=Bars-i-1; i >= 0 ; i--,r++)
      {  
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>Bars-2)
         {
            emas[r][0] = price;
            emas[r][1] = price;
            macd[i]    = 0;
            signal[i]  = 0;
            continue;
         }

         emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
         emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
         macd[i]    = emas[r][0]-emas[r][1];
         macdDa[i]  = EMPTY_VALUE;
         macdDb[i]  = EMPTY_VALUE;
         signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
         colors[i]  = colors[i+1];
         trend[r]   = trend[r-1];
            if (macd[i]>signal[i]) trend[r]  =  1;
            if (macd[i]<signal[i]) trend[r]  = -1;
            if (macd[i]>macd[i+1]) colors[i] =  1;
            if (macd[i]<macd[i+1]) colors[i] = -1;
            if (colors[i]==-1) PlotPoint(i,macdDa,macdDb,macd);
      
         //
         //
         //
         //
         //
      
         double valMin = macd[ArrayMinimum(macd,MinMaxPeriod,i)];
         double valMax = macd[ArrayMaximum(macd,MinMaxPeriod,i)];
         double range  = valMax-valMin;
               levelUp[i] = valMin+range*LevelUp/100.0;
               levelMi[i] = valMin+range*0.5;
               levelDn[i] = valMin+range*LevelDown/100.0;
               manageArrow(i);
      }         
      manageAlerts();
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (colors[limit]==-1) CleanPoint(limit,macdDa,macdDb);
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         levelUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,0,y);
         levelMi[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,1,y);
         levelDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,2,y);
         macd[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,3,y);
         signal[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,6,y);
         colors[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastEMA,SlowEMA,SignalEMA,Price,MinMaxPeriod,LevelUp,LevelDown,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ArrowsVisible,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,7,y);
         macdDa[i]  = EMPTY_VALUE;
         macdDb[i]  = EMPTY_VALUE;

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  levelUp[i+k] = levelUp[i] + (levelUp[i+n] - levelUp[i])*k/n;
                  levelMi[i+k] = levelMi[i] + (levelMi[i+n] - levelMi[i])*k/n;
                  levelDn[i+k] = levelDn[i] + (levelDn[i+n] - levelDn[i])*k/n;
                  signal[i+k]  = signal[i]  + (signal[i+n]  - signal[i] )*k/n;
                  macd[i+k]    = macd[i]    + (macd[i+n]    - macd[i]   )*k/n;
               }                  
   }
   for (i=limit; i>=0; i--) if (colors[i]==-1) PlotPoint(i,macdDa,macdDb,macd);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (ArrowsVisible)
   {
      ObjectDelete(ArrowsIdentifier+Time[i]);         
            
      //
      //
      //
      //
      //

      int r = Bars-i-1;           
      if (trend[r] != trend[r-1])
      {
         string name = ArrowsIdentifier+Time[i];
         if (trend[r] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,241);
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,242);
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
         }
      }
   }
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; int forBar = Bars-whichBar-1;
      if (trend[forBar] != trend[forBar-1])
      {
         if (trend[forBar] == 1) doAlert(whichBar,"up");
         if (trend[forBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD crosses signal line ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MACD floating levels"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}